#include <math.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/wait.h>
#include <unistd.h>
#include "raz.h"
#include "util.h"
#include "config.h"

#define BASEFN	"bip"

#define X0	1.0
#define	Y0	1.0
#define G	9.8


double	L = 1;

double fo(double x[VARS]) {

return(-sin(x[1]-x[2])*pow(x[4],2) - 2*(G/L)*sin(x[1]));

}

double go(double x[VARS]) {

return(sin(x[1]-x[2])*pow(x[3],2) - (G/L)*sin(x[2]));

}

double f(double x[VARS]) {

return( (fo(x) - cos(x[1]-x[2])*go(x))/(2-pow(cos(x[1]-x[2]),2)) );

}

double g(double x[VARS]) {

return( (2*go(x) - cos(x[1]-x[2])*fo(x))/(2-pow(cos(x[1]-x[2]),2)) );

}




int main(int argc, char **argv) {


double	T = 25,
	dt = 0.01,
	x[INUM][VARS],
	m[2] = {0.0, 0.0};

int	keep = -1,
	print = 0,
	autorun = 0,
	mode = RKG,
	datafd = 1,
	gplotfd = 1,
	stop = 0,
	cpid,
	ni = 0;

char	buf[BUFSIZE] = "\0",
	fname[FNSIZE] = "\0";



printf("Programma per lo studio dell'equazione del bipendolo\n\n");
printf("Raz version %s, Copyright (C) 1999 Marco Gaiarin e Jacopo Pietropolli Charmet\n",VERSION);
printf("Raz comes with ABSOLUTELY NO WARRANTY, under GNU GPL Licence\n");
printf("This is free software, and you are welcome to redistribute it\n");
printf("under certain conditions; see COPYRIGHT file on source distribution\n\n");
                
printf("Eq. del BiPendolo:\tdx/dt = v\n\t\t\tdy/dt = w\n\t\t\t2*dv/dt+cos(x-y)*dw/dt = - sin(x-y)*w^2 - 2*g/L*sin(x)\n\t\t\tdv/dt*cos(x-y)+ dw/dt = sin(x-y)*v^2 - g/L*sin(y)\n\n");

InputD("Inserisci il parametro", "L", &L);

printf("\n");
while ( (ni < INUM) && (stop == 0) ) {
	x[ni][0] = 0;
	x[ni][1] = X0;
	x[ni][2] = Y0;
	x[ni][3] = 0;
	x[ni][4] = 0;
	InputD("Inserisci l'angolo iniziale", "x0", &x[ni][1]);
	InputD("Inserisci la velocita` iniziale", "y0", &x[ni][2]);
	ni++;
	stop = InputYN("Ancora?!", 1);
}

printf("\n");
if ( InputYN("Vuoi il plot in modulo?", 1) == 0 ) {
  m[0] = M_PI;
  m[1] = M_PI;
}

printf("\n");
InputD("Inserisci l'intervallo", "dt", &dt);
InputD("Inserisci il tempo totale", "T", &T);
printf("  %d punti da calcolare.\n", (int)(T/dt)*ni);

printf("\n");
mode = InputO("Quale metodo di integrazione (eu, eu2, rk, rkg)?",RKG);

printf("\n");
if ( (autorun = InputYN("Vuoi che gnuplot venga eseguito automaticamente?", 0)) == 0 )
	keep = InputYN("Vuoi mantenere i file per gnuplot?", 1);
else
	keep = 0;
print = InputYN("Vuoi la stampa su file PostScript?", 1);

printf("\n");



sprintf(fname, "%s.gplot", BASEFN);
if ( (gplotfd = open(fname, O_CREAT|O_WRONLY|O_TRUNC, 00644)) < 0 ) {
	perror("Errore aprendo il file gnuplot");
	exit(-1);
}
printf("Scrivo il file gnuplot %s.", fname);
sprintf(buf, "Il BiPendolo L=%f\\nmetodo=%s, dt=%f, T=%f", L, intgm[mode], dt, T);
WriteGPlot(gplotfd, print, 0, BASEFN, buf, "x", "y");
close(gplotfd);
printf(". fatto.\n");


sprintf(fname, "%s.dat", BASEFN);
if ( (datafd = open(fname, O_CREAT|O_WRONLY|O_TRUNC, 00644)) < 0 ) {
	perror("Errore aprendo il file dati");
	exit(-1);
}
printf("Scrivo il file dati %s.", fname);
for (cpid = 0; cpid < ni; cpid++) {
	sprintf(buf, "# Il BiPendolo\n# L=%f\n# x0=%f, v0=%f, metodo=%s, dt=%f, T=%f\n#\n", L, x[cpid][1], x[cpid][2], intgm[mode], dt, T);
	WriteData(datafd, buf, mode, 1, m, x[cpid], 1, 2, T, dt, f, g);
}
close(datafd);
printf(". fatto.\n");



if ( autorun == 0 ) {
	switch (cpid = fork()) {
	
	case -1: // errore!
		printf("Errore facendo fork()");
		break;
	
	case 0:	// il figlio
	
		sprintf(fname, "%s.gplot", BASEFN);
		execlp(GNUPLOT, GNUPLOT, fname, NULL);

		exit(0);	// non dovrebbe arrivarci mai ;-)))

	default: // il padre 

		if (waitpid(cpid, NULL, 0) < 0)
			perror("Errore facendo wait()");


		break;
	}
}

if ( keep != 0 ) {
	printf("Elimino i file dati.\n");
	sprintf(fname, "%s.dat", BASEFN);
	unlink(fname);
	sprintf(fname, "%s.gplot", BASEFN);
	unlink(fname);
}

exit(0);

} // main()


