#include <math.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/wait.h>
#include <unistd.h>
#include "raz.h"
#include "util.h"
#include "config.h"

#define	BASEFN	"lotka"

#define	X0	2
#define	Y0	1


double	A = 2,
	B = 1,
	C = 1,
	D = 1,
	E = 0.01;



double f(double x[VARS]) {

return(A*x[3]-B*x[3]*x[4]-E*x[3]*x[3]);

}

double g(double x[VARS]) {

return(-C*x[4]+D*x[3]*x[4]);

}



int main(int argc, char **argv) {


double	T = 50,
	dt = 0.01,
	x[INUM][VARS];
const double
	m[2] = {0.0, 0.0};

int	keep = -1,
	print = 0,
	autorun = 0,
	mode = RK,
	datafd = -1,
	gplotfd = -1,
	stop = 0,
	cpid,
	ni = 0;

char	buf[BUFSIZE] = "\0",
	fname[FNSIZE] = "\0";



printf("Programma per lo studio dell'equazione di Lotka-Volterra\n\n");
printf("Raz version %s, Copyright (C) 1999 Marco Gaiarin e Jacopo Pietropolli Charmet\n",VERSION);
printf("Raz comes with ABSOLUTELY NO WARRANTY, under GNU GPL Licence\n");
printf("This is free software, and you are welcome to redistribute it\n");
printf("under certain conditions; see COPYRIGHT file on source distribution\n\n");
                
printf("Eq. di L-V:\tdx/dt = A*x-B*x*y-E*x*x\n\t\tdy/dt = -C*y+D*x*y\n\n");

InputD("Inserisci il parametro", "A", &A);
InputD("Inserisci il parametro", "B", &B);
InputD("Inserisci il parametro", "C", &C);
InputD("Inserisci il parametro", "D", &D);
InputD("Inserisci il parametro", "E", &E);
printf("\n");
while ( (ni < INUM) && (stop == 0) ) {
	x[ni][0] = 0;
	x[ni][1] = 0;
	x[ni][2] = 0;
	x[ni][3] = X0;
	x[ni][4] = Y0;
	InputD("Inserisci la x iniziale", "x0", &x[ni][3]);
	InputD("Inserisci la y iniziale", "y0", &x[ni][4]);
	ni++;
	stop = InputYN("Ancora?!", 1);
}


printf("\n");
InputD("Inserisci l'intervallo", "dt", &dt);
InputD("Inserisci il tempo totale", "T", &T);
printf("  %d punti da calcolare.\n", (int)(T/dt)*ni);

printf("\n");
mode = InputO("Quale metodo di integrazione (eu, eu2, rk, rkg)?",RKG);

printf("\n");
if ( (autorun = InputYN("Vuoi che gnuplot venga eseguito automaticamente?", 0)) == 0 )
	keep = InputYN("Vuoi mantenere i file per gnuplot?", 1);
else
	keep = 0;
print = InputYN("Vuoi la stampa su file PostScript?", 1);

printf("\n");


sprintf(fname, "%s.gplot", BASEFN);
if ( (gplotfd = open(fname, O_CREAT|O_WRONLY|O_TRUNC, 00644)) < 0 ) {
	perror("Errore aprendo il file gnuplot");
	exit(-1);
}
printf("Scrivo il file gnuplot %s.", fname);
sprintf(buf, "Lotka-Volterra: A=%f, B=%f, C=%f, D=%f, E=%f\\ndt=%f, T=%f, metodo=%s", A, B, C, D, E, dt, T, intgm[mode]);
WriteGPlot(gplotfd, print, 0, BASEFN, buf, "Popolazione x", "Popolazione y");
close(gplotfd);
printf(". fatto\n");

sprintf(fname, "%s.dat", BASEFN);
if ( (datafd = open(fname, O_CREAT|O_WRONLY|O_TRUNC, 00644)) < 0 ) {
	perror("Errore aprendo il file dati");
	exit(-1);
}
printf("Scrivo il file dati %s.", fname);
for (cpid = 0; cpid < ni; cpid++) {
	sprintf(buf, "# Lotka-Volterra\n# A=%f, B=%f, C=%f, D=%f, E=%f\n# x0=%f, y0=%f, dt=%f, T=%f, metodo=%s\n#\n", A, B, C, D, E, x[cpid][3], x[cpid][4], dt, T, intgm[mode]);
	WriteData(datafd, buf, mode, 1, m, x[cpid], 3, 4, T, dt, f, g);
}
close(datafd);
printf(". fatto.\n");



if ( autorun == 0 ) {
	switch (cpid = fork()) {
	
	case -1: // errore!

		perror("Errore facendo fork()");
		break;
	
	case 0:	// il figlio
	
		sprintf(fname, "%s.gplot", BASEFN);
		execlp(GNUPLOT, GNUPLOT, fname, NULL);

		exit(0);	// non dovrebbe arrivarci mai ;-)))

	default: // il padre 

		if (waitpid(cpid, NULL, 0) < 0)
			perror("Errore facendo wait()");

		break;
	}
}


if ( keep != 0 ) {
	printf("Elimino i file dati.\n");
	sprintf(fname, "%s.dat", BASEFN);
	unlink(fname);
	sprintf(fname, "%s.gplot", BASEFN);
	unlink(fname);
}

exit(0);

} // main()


