#include <math.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/wait.h>
#include <unistd.h>
#include "raz.h"
#include "util.h"
#include "config.h"

#define BASEFN	"osc"

#define X0	0
#define	Y0	0
#define SQRT2	1.41421356

double	o = 1.0,
	O = 1.2,
	C = 1.0;


double f(double x[VARS]) {

return(x[4]);

}

double g(double x[VARS]) {

return(-pow(o,2)*x[3]+C*cos(O*x[0]));

}



int main(int argc, char **argv) {


double	T = 100,
	dt = 0.01,
	x[INUM][VARS];
const double
	m[2] = {0.0, 0.0};

int	keep = -1,
	print = 0,
	autorun = 0,
	mode = RK,
	datafd = 1,
	gplotfd = 1,
	stop = 0,
	cpid,
	ni = 0;

char	buf[BUFSIZE] = "\0",
	fname[FNSIZE] = "\0";



printf("Programma per lo studio dell'equazione dell'oscillatore armonico forzato\n\n");
printf("Raz version %s, Copyright (C) 1999 Marco Gaiarin e Jacopo Pietropolli Charmet\n",VERSION);
printf("Raz comes with ABSOLUTELY NO WARRANTY, under GNU GPL Licence\n");
printf("This is free software, and you are welcome to redistribute it\n");
printf("under certain conditions; see COPYRIGHT file on source distribution\n\n");
                
printf("Eq. del Pendolo:\tdx/dt = v\n\t\t\tdv/dt = -o^2*x+C^2*cos(Ot)\n\n");

InputD("Inserisci il parametro", "o", &o);
InputD("Inserisci il parametro", "C", &C);
InputD("Inserisci il parametro", "O", &O);

printf("\n");
while ( (ni < INUM) && (stop == 0) ) {
	x[ni][0] = 0;
	x[ni][1] = 0;
	x[ni][2] = 0;
	x[ni][3] = X0;
	x[ni][4] = Y0;
	InputD("Inserisci l'angolo iniziale", "x0", &x[ni][3]);
	InputD("Inserisci la velocita` iniziale", "v0", &x[ni][4]);
	ni++;
	stop = InputYN("Ancora?!", 1);
}

printf("\n");
InputD("Inserisci l'intervallo", "dt", &dt);
InputD("Inserisci il tempo totale", "T", &T);
printf("  %d punti da calcolare\n", (int)(T/dt)*ni);

printf("\n");
mode = InputO("Quale metodo di integrazione (eu, eu2, rk, rkg)?", RKG);

printf("\n");
if ( (autorun = InputYN("Vuoi che gnuplot venga eseguito automaticamente?", 0)) == 0 )
	keep = InputYN("Vuoi mantenere i file per gnuplot?", 1);
else
	keep = 0;
print = InputYN("Vuoi la stampa su file PostScript?", 1);

printf("\n");



snprintf(fname, FNSIZE, "%s.gplot", BASEFN);
if ( (gplotfd = open(fname, O_CREAT|O_WRONLY|O_TRUNC, 00644)) < 0 ) {
	perror("Errore aprendo il file gnuplot");
	exit(-1);
}
printf("Scrivo il file gnuplot %s.", fname);
snprintf(buf, BUFSIZE, "L'Oscillatore armonico forzato: o=%f, C=%f, O=%f\\nmetodo=%s, dt=%f, T=%f", o, C, O, intgm[mode], dt, T);
WriteGPlot(gplotfd, print, 0, BASEFN, buf, "t", "x");
close(gplotfd);
printf(". fatto.\n");


snprintf(fname, FNSIZE, "%s.dat", BASEFN);
if ( (datafd = open(fname, O_CREAT|O_WRONLY|O_TRUNC, 00644)) < 0 ) {
	perror("Errore aprendo il file dati");
	exit(-1);
}
printf("Scrivo il file dati %s.", fname);
for (cpid = 0; cpid < ni; cpid++) {
	snprintf(buf, BUFSIZE, "# L'Oscillatore armonico forzato\n# o=%f, C=%f, O=%f\n# x0=%f, v0=%f, metodo=%s, dt=%f, T=%f\n", o, C, O, x[cpid][3], x[cpid][4], intgm[mode], dt, T);
	WriteData(datafd, buf, mode, 1, m, x[cpid], 0, 3, T, dt, f, g);
}
close(datafd);
printf(". fatto.\n");



if ( autorun == 0 ) {
	switch (cpid = fork()) {
	
	case -1: // errore!
		printf("Errore facendo fork()");
		break;
	
	case 0:	// il figlio
	
		snprintf(fname, FNSIZE, "%s.gplot", BASEFN);
		execlp(GNUPLOT, GNUPLOT, fname, NULL);

		exit(0);	// non dovrebbe arrivarci mai ;-)))

	default: // il padre 

		if (waitpid(cpid, NULL, 0) < 0)
			perror("Errore facendo wait()");


		break;
	}
}

if ( keep != 0 ) {
	printf("Elimino i file dati.\n");
	snprintf(fname, FNSIZE, "%s.dat", BASEFN);
	unlink(fname);
	snprintf(fname, FNSIZE, "%s.gplot", BASEFN);
	unlink(fname);
}

exit(0);

} // main()


