#include <math.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/wait.h>
#include <unistd.h>
#include "raz.h"
#include "util.h"
#include "config.h"

#define BASEFN	"pendolo"

#define X0	0.5
#define	Y0	0


double	O = 2,
	M = 2.25,
	B = 0.15;


double f(double x[VARS]) {

return(x[4]);

}

double g(double x[VARS]) {

return(-pow(O,2)*sin(x[3])+pow(M,2)*sin(x[3])*cos(x[3])-2*B*x[4]);

}






int main(int argc, char **argv) {


double	T = 25,
	dt = 0.01,
	x[INUM][VARS],
	m[2] = {0.0, 0.0};

int	keep = -1,
	print = 0,
	autorun = 0,
	mode = RK,
	datafd = 1,
	gplotfd = 1,
	stop = 0,
	cpid,
	ni = 0;

char	buf[BUFSIZE] = "\0",
	fname[FNSIZE] = "\0";



printf("Programma per lo studio dell'equazione del pendolo\n\n");
printf("Raz version %s, Copyright (C) 1999 Marco Gaiarin e Jacopo Pietropolli Charmet\n",VERSION);
printf("Raz comes with ABSOLUTELY NO WARRANTY, under GNU GPL Licence\n");
printf("This is free software, and you are welcome to redistribute it\n");
printf("under certain conditions; see COPYRIGHT file on source distribution\n\n");
                
printf("Eq. del Pendolo:\tdx/dt = v\n\t\t\tdv/dt = -O^2*sin(x)+M^2*sin(x)*cos(x)-2*B*y\n\n");

InputD("Inserisci il parametro", "O", &O);
InputD("Inserisci il parametro", "M", &M);
InputD("Inserisci il parametro", "B", &B);

printf("\n");
while ( (ni < INUM) && (stop == 0) ) {
	x[ni][0] = 0;
	x[ni][1] = 0;
	x[ni][2] = 0;
	x[ni][3] = X0;
	x[ni][4] = Y0;
	InputD("Inserisci l'angolo iniziale", "x0", &x[ni][3]);
	InputD("Inserisci la velocita` iniziale", "v0", &x[ni][4]);
	ni++;
	stop = InputYN("Ancora?!", 1);
}

printf("\n");
if ( (M == 0.0) && (B == 0.0) )
  if ( InputYN("Vuoi il plot in modulo?", 1) == 0 )
    m[0] = M_PI;

printf("\n");
InputD("Inserisci l'intervallo", "dt", &dt);
InputD("Inserisci il tempo totale", "T", &T);
printf("  %d punti da calcolare.\n", (int)(T/dt)*ni);

printf("\n");
mode = InputO("Quale metodo di integrazione (eu, eu2, rk, rkg)?",RKG);

printf("\n");
if ( (autorun = InputYN("Vuoi che gnuplot venga eseguito automaticamente?", 0)) == 0 )
	keep = InputYN("Vuoi mantenere i file per gnuplot?", 1);
else
	keep = 0;
print = InputYN("Vuoi la stampa su file PostScript?", 1);

printf("\n");



sprintf(fname, "%s.gplot", BASEFN);
if ( (gplotfd = open(fname, O_CREAT|O_WRONLY|O_TRUNC, 00644)) < 0 ) {
	perror("Errore aprendo il file gnuplot");
	exit(-1);
}
printf("Scrivo il file gnuplot %s.", fname);
sprintf(buf, "Il Pendolo O=%f, M=%f, B=%f\\nmetodo=%s, dt=%f, T=%f", O, M, B, intgm[mode], dt, T);
WriteGPlot(gplotfd, print, 0, BASEFN, buf, "x", "v");
close(gplotfd);
printf(". fatto.\n");


sprintf(fname, "%s.dat", BASEFN);
if ( (datafd = open(fname, O_CREAT|O_WRONLY|O_TRUNC, 00644)) < 0 ) {
	perror("Errore aprendo il file dati");
	exit(-1);
}
printf("Scrivo il file dati %s.", fname);
for (cpid = 0; cpid < ni; cpid++) {
	sprintf(buf, "# Il Pendolo\n# O=%f, M=%f, B=%f\n# x0=%f, v0=%f, metodo=%s, dt=%f, T=%f\n#\n", O, M, B, x[cpid][3], x[cpid][4], intgm[mode], dt, T);
	WriteData(datafd, buf, mode, 1, m, x[cpid], 3, 4, T, dt, f, g);
}
close(datafd);
printf(". fatto.\n");



if ( autorun == 0 ) {
	switch (cpid = fork()) {
	
	case -1: // errore!
		printf("Errore facendo fork()");
		break;
	
	case 0:	// il figlio
	
		sprintf(fname, "%s.gplot", BASEFN);
		execlp(GNUPLOT, GNUPLOT, fname, NULL);

		exit(0);	// non dovrebbe arrivarci mai ;-)))

	default: // il padre 

		if (waitpid(cpid, NULL, 0) < 0)
			perror("Errore facendo wait()");


		break;
	}
}

if ( keep != 0 ) {
	printf("Elimino i file dati.\n");
	sprintf(fname, "%s.dat", BASEFN);
	unlink(fname);
	sprintf(fname, "%s.gplot", BASEFN);
	unlink(fname);
}

exit(0);

} // main()


