/*
 *  raz.h: library of numerical integration routines - header file
 *  Copyright (C) 1999  Marco Gaiarin <gaio@dei.unipd.it> and
 *			Jacopo Pietropolli Charmet <cico@dei.unipd.it>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#define	EU	0		// tipi di integrazione
#define EU2	1
#define RK	2
#define RKG	3

#define S	0.5		// Parametri per RKG
#define Q	1-sqrt(S)
#define P	1+sqrt(S)

#define	VARS	5

extern	double	xa[VARS];	// Variabili per RKG, usate anche dagli
				// altri


extern int Eulero(double *x[VARS], double dt,
	double f(double[VARS]), double g(double[VARS]) );
extern int Eulero2(double *x[VARS], double dt,
	double f(double[VARS]), double g(double[VARS]) );
extern int RungeKutta(double *x[VARS], double dt,
	double f(double[VARS]), double g(double[VARS]) );
extern int RungeKuttaGill(double *x[VARS], double dt,
	double f(double[VARS]), double g(double[VARS]) );
