#include <math.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/wait.h>
#include <unistd.h>
#include "raz.h"
#include "util.h"
#include "config.h"

#define	BASEFN	"rosy\0"

#define X0	0.75
#define	Y0	0


double	A = 1.5,
	K = 1,
	M = 1;



double f(double x[VARS]) {

return(x[1]*pow(x[4],2)-K*pow(x[1],-A));

}

double g(double x[VARS]) {

return(-2*(x[3]*x[4])/x[1]);

}



int main(int argc, char **argv) {


double	T = 25,
	dt = 0.01,
	x[INUM][VARS];
const double
	m[2] = {0.0, 0.0};

int	keep = -1,
	print = 0,
	autorun = 0,
	mode = RK,
	stop = 0,
	datafd = -1,
	gplotfd = -1,
	cpid,
	ni = 0;

char	buf[256] = "\0",
	fname[FNSIZE] = "\0";



printf("Programma per lo studio dell'equazione di Keplero/completa (rosetta)\n\n");
printf("Raz version %s, Copyright (C) 1999 Marco Gaiarin e Jacopo Pietropolli Charmet\n",VERSION);
printf("Raz comes with ABSOLUTELY NO WARRANTY, under GNU GPL Licence\n");
printf("This is free software, and you are welcome to redistribute it\n");
printf("under certain conditions; see COPYRIGHT file on source distribution\n\n");
                
printf("Eq. di Keplero:\tdr/dt   = vr\n\t\tdth/dt  = vth\n\t\tdvr/dt  = r*vth^2 - K/r^-A\n\t\tdvth/dt = -2*(vr*vth)/r\n\n");

InputD("Inserisci il parametro", "A", &A);
InputD("Inserisci il parametro", "K", &K);

printf("\n");
while ( (ni < INUM) && (stop == 0) ) {
	x[ni][0] = 0;
	x[ni][1] = X0;
	x[ni][2] = 0;
	x[ni][3] = 0;
	InputD("Inserisci la r iniziale", "r0", &x[ni][1]);
	InputD("Inserisci il momento angolare iniziale", "M", &M);
	x[ni][4] = M*pow(x[ni][1],-2);
	ni++;
	stop = InputYN("Ancora?!", 1);
}

printf("\n");
InputD("Inserisci l'intervallo", "dt", &dt);
InputD("Inserisci il tempo totale", "T", &T);
printf("  %d punti da calcolare.\n", (int)(T/dt)*ni);

printf("\n");
mode = InputO("Quale metodo di integrazione (eu, eu2, rk, rkg)?",RKG);

printf("\n");
if ( (autorun = InputYN("Vuoi che gnuplot venga eseguito automaticamente?", 0)) == 0)
	keep = InputYN("Vuoi mantenere i file per gnuplot?", 1);
else
	keep = 0;
print = InputYN("Vuoi la stampa su file PostScript?", 1);

printf("\n");


sprintf(fname, "%s.gplot", BASEFN);
if ( (gplotfd = open(fname, O_CREAT|O_WRONLY|O_TRUNC, 00644)) < 0 ) {
	perror("Errore aprendo il file gnuplot");
	exit(-1);
}
printf("Scrivo il file gnuplot %s.", fname);

sprintf(buf, "Keplero/rosetta: K= %f, A=%f\\ndt=%f, T=%f, metodo=%s", K, A, dt, T, intgm[mode]);
WriteGPlot(gplotfd, print, 1, BASEFN, buf, "r", "th");
close(gplotfd);
printf(". fatto\n");

sprintf(fname, "%s.dat", BASEFN);
if ( (datafd = open(fname, O_CREAT|O_WRONLY|O_TRUNC, 00644)) < 0 ) {
	perror("Errore aprendo il file dati");
	exit(-1);
}
printf("Scrivo il file dati %s.", fname);
for (cpid = 0; cpid < ni; cpid++) {
	sprintf(buf, "# Keplero/rosetta\n# K=%f, A=%f, M=%f\n# r0=%f, th0=%f, dt=%f, T=%f, metodo=%s\n#\n", K, A, M, x[cpid][1], x[cpid][2], dt, T, intgm[mode]);
	WriteData(datafd, buf, mode, 1, m, x[cpid], 2, 1, T, dt, f, g);
}
close(datafd);
printf(". fatto.\n");



if ( autorun == 0 ) {
	switch (cpid = fork()) {
	
	case -1: // errore!

		perror("Errore facendo fork()");
		break;
	
	case 0:	// il figlio
	
		sprintf(fname, "%s.gplot", BASEFN);
		execlp(GNUPLOT, GNUPLOT, fname, NULL);

		exit(0);	// non dovrebbe arrivarci mai ;-)))

	default: // il padre 

		if (waitpid(cpid, NULL, 0) < 0)
			perror("Errore facendo wait()");


		break;
	}
}


if ( keep != 0 ) {
	printf("Elimino i file dati.\n");
	sprintf(fname, "%s.dat", BASEFN);
	unlink(fname);
	sprintf(fname, "%s.gplot", BASEFN);
	unlink(fname);
}

exit(0);

} // main()


