#include <stdio.h>
#include <math.h>
#include <string.h>
#include <unistd.h>
#include "util.h"

// metodi di integrazione possibili
const	char	intgm[ONUM][OSIZE] = {"eu\0", "eu2\0", "rk\0", "rkg\0"};


/*	InputD - Input di un double
 *
 */
int InputD(char *msg, char *vname, double *v) {

double	tin = 0;
char	in[INSIZE];

while (tin <= 0) {
	printf("%s %s[%f]: ", msg, vname, *v);
	if ( fgets(in, INSIZE, stdin) != NULL ) {
		if (strlen((char *)in) <= 1)
			tin = 1;
		else
			tin = sscanf(in, "%lf", v);
	}
}

return(tin);

} //InputD


/* InputYN - input di una opzione si/no
 *
 */
int InputYN(char *msg, int def) {

char    in[INSIZE];
const	char	ynm[2][2] = {"y\0", "n\0"};

printf("%s [%s]: ", msg, ynm[def]);
if ( (fgets(in, INSIZE, stdin) != NULL) && (strlen((char *)in) > 1) )
	return( strncmp(in, "y", 1) );
else
	return(def);

} //InputYN


/* InputO - input delle opzioni di integrazione
 *
 */
int InputO(char *msg, int def) {

char	in[INSIZE];
int	i;


while (13 == 13) {

printf("%s [%s]: ", msg, intgm[def]);
if ( ( fgets(in, INSIZE, stdin) == NULL ) || (strlen((char *)in) < 2) )
	return(def);

for (i = 3; i > -1; i--) {

if ( strncmp(in, intgm[i], strlen(intgm[i])) == 0 )
	return(i);

}

}

return(def);	// tanto non ci arrivo mai! ;)

} // InputO



void WriteData(int fd, char *head, int mode, int s, const double m[2],
	double x[VARS], int a, int b, double T, double dt,
	double f(double[VARS]), double g(double[VARS])) {

char	buf[BUFSIZE] = "\0";
int	i = 0;

write(fd, head, strlen(head));

while ( x[0] < T) {

if ( (i % s) == 0 ) {
  if ( (m[0] == 0.0) || (x[a] == 0.0) )
    sprintf(buf, "%f ", x[a]);
  else
    sprintf(buf, "%f ", (x[a] - 2*m[0]*(int)((x[a]+m[0]*(int)x[a]/fabs(x[a]))/(2*m[0]))));
  write(fd, buf, strlen(buf));

  if ( (m[1] == 0.0) || (x[b] == 0.0) )
    sprintf(buf, "%f\n", x[b]);
  else
    sprintf(buf, "%f\n", (x[b] - 2*m[1]*(int)((x[b]+m[1]*(int)x[b]/fabs(x[b]))/(2*m[1])))); 
  write(fd, buf, strlen(buf));
}

switch ( mode ) {

case EU:
	Eulero(&x, dt, f, g);
	break;

case EU2:
	Eulero2(&x, dt, f, g);
	break;

case RK:
	RungeKutta(&x, dt, f, g);
	break;

case RKG:
	RungeKuttaGill(&x, dt, f, g);
	break;
}

i = (int)(x[0]/dt);
	
}
} // WriteData


void WriteGPlot(int fd, int print, int mode, char *basefn,
	char *title, char *xlabel, char *ylabel) {

char	buf[BUFSIZE] = "\0";

write(fd, "# ", 2);
write(fd, title , strlen(title));
write(fd, "#\n", 2);

sprintf(buf, "set autoscale\nset title \"");
write(fd, buf, strlen(buf));
write(fd, title, strlen(title));
write(fd, "\"\n", 2);
sprintf(buf, "set xlabel '%s'\nset ylabel '%s'\n", xlabel, ylabel);
write(fd, buf, strlen(buf));
if (mode == 1) {
	sprintf(buf, "set polar\n");
	write(fd, buf, strlen(buf));
}
sprintf(buf, "set zeroaxis\nset data style dot\n");
write(fd, buf, strlen(buf));
if ( print == 0 ) {
	sprintf(buf, "set terminal postscript\nset output '%s.ps'\n", basefn);
	write(fd, buf, strlen(buf));
}
sprintf(buf, "\nplot '%s.dat'\n\n", basefn);
write(fd, buf, strlen(buf));
if ( print != 0) {
	sprintf(buf, "pause -1 'Premi un tasto'\n\n");
	write(fd, buf, strlen(buf));
}
sprintf(buf, "\nquit\n\n");
write(fd, buf, strlen(buf));

} // WriteGPlot

